import MuseScore 3.0
import QtQuick 2.9
MuseScore {
  menuPath: "Plugins.Dynamics Clear"
  version: "220918"
  onRun:{
  var bForceInstrDyn=true
  var es=curScore.selection.elements
  function tick(e){return e.parent.parent.tick || e.parent.tick} //NOTE || CHORD,REST
  function indexOf(ps,p){for(var i in ps){if(p.is(ps[i])) return i}}
  function getElement(track,tick){
    var c=curScore.newCursor()
    c.track=track
    c.rewindToTick(tick) 
    var e=c.segment.elementAt(track)
    return e
  }
  for(var i in es){
    var e=es[i].type==Element.DYNAMIC? getElement(es[i].track, es[i].parent.tick) : es[i]
    if(~[Element.NOTE,  Element.CHORD,Element.REST].indexOf(e.type)){
      getDyn(e, function(d){removeElement(d)})
      if(bForceInstrDyn) getDyn(getElement((e.parent.staff||e.staff).part.startTrack, e.parent.parent.tick || e.parent.tick), function(d){removeElement(d)})
    }
  }
  function getDyn(e,cb){
    var a=e.parent.parent.annotations || e.parent.annotations  //segment //NOTE || CHORD,REST
    if(a!=undefined)
      for (var n in a)
        if(a[n].type==Element.DYNAMIC && a[n].track==e.track) cb( a[n] )
  }
  }
} 